package greenfoot.junitUtils.runner;

import org.junit.runner.Description;
import org.junit.runner.notification.RunListener;
import org.junit.runner.notification.RunNotifier;
import org.junit.runners.BlockJUnit4ClassRunner;
import org.junit.runners.model.InitializationError;

import greenfoot.junitUtils.EventDispatch;

/**
 * NameTest can use GreenfootRunner as next:
 * 
 *     import ...
 *     import org.junit.runner.RunWith;
 *     import greenfoot.junitUtils.runner.GreenfootRunner;
 *     
 *     @RunWith(GreenfootRunner.class)
 *     public class NameTest {
 *        ...
 *     }
 *     
 * @author Francisco Guerra (francisco.guerra@ulpgc.es)
 *
 */
public class GreenfootRunner extends BlockJUnit4ClassRunner {

    public GreenfootRunner (Class<?> clazz) throws InitializationError {
        super(clazz);
    }
    
    @Override
    public void run(RunNotifier notifier) {
        notifier.addListener(new RunListener() {

                @Override
                public void testStarted(Description description) throws Exception {
                    TestRunnerState.beginUnitTest();
            	    TestRunnerState.resetOutputs();	        
                }

                @Override
                public void testFinished(Description description) throws Exception {
        			EventDispatch.keyboardExited();
        			EventDispatch.mouseExited();
                    TestRunnerState.resetInputs();
                    TestRunnerState.endUnitTest();
                }

            });
        super.run(notifier);
    }
}
