package greenfoot.junitUtils.runner;

import org.junit.jupiter.api.extension.AfterEachCallback;
import org.junit.jupiter.api.extension.BeforeEachCallback;
import org.junit.jupiter.api.extension.ExtensionContext;

import greenfoot.junitUtils.EventDispatch;

/**
 * NameTest can use JUnitRunner as next:
 * 
 *     import ...
 *     import org.junit.jupiter.api.extension.ExtendWith;
 *     import greenfoot.junitUtils.runner.JUnit5GreenfootRunner;
 *     
 *     @ExtendWith(JUnit5GreenfootRunner.class)
 *     public class NameTest {
 *        ...
 *     }
 *     
 * @author Francisco Guerra (francisco.guerra@ulpgc.es)
 *
 */
public class JUnit5Runner implements BeforeEachCallback, AfterEachCallback {   
	
	@Override
	public void beforeEach(ExtensionContext arg0) throws Exception {
       TestRunnerState.beginUnitTest();
	   TestRunnerState.resetOutputs();	        
	}

	@Override
	public void afterEach(ExtensionContext arg0) throws Exception {
		EventDispatch.keyboardExited();
		EventDispatch.mouseExited();
        TestRunnerState.resetInputs();
        TestRunnerState.endUnitTest();
	}

}

